Index: trunk/LMDZ.GENERIC/libf/aeronostd/photochemistry_asis.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/aeronostd/photochemistry_asis.F90	(revision 2541)
+++ trunk/LMDZ.GENERIC/libf/aeronostd/photochemistry_asis.F90	(revision 2542)
@@ -1139,471 +858,187 @@
 
 use types_asis
+use datafile_mod
+use ioipsl_getin_p_mod, only: getin_p
+use tracer_h, only: nesp
+use chimiedata_h
+use callkeys_mod, only: jonline
 
 implicit none
 
-#include "chimiedata.h"
-
-! input
-
-integer :: i_co2, i_co, i_o, i_o1d, i_o2, i_o3, i_h,       &
-           i_h2, i_oh, i_ho2, i_h2o2, i_h2o,               &
-           i_n, i_n2d, i_no, i_no2, i_n2
+! output
+
+integer, intent(out)              :: nreact          ! number of reactions in reactions files
+integer, allocatable, intent(out) :: rtype(:)        ! reaction rate type
+integer, allocatable, intent(out) :: third_body(:)   ! if the reaction have a third body: index of the third body, else zero
+logical, allocatable, intent(out) :: three_prod(:)   ! if the reaction have a three defferent proucts egal .true.
 
 ! local
 
 integer :: nb_phot, nb_reaction_3, nb_reaction_4
-integer :: i_dummy
-
-allocate (indice_phot(nb_phot_max))
-allocate (indice_3(nb_reaction_3_max))
-allocate (indice_4(nb_reaction_4_max))
-
-i_dummy = 1
-
-nb_phot       = 0
-nb_reaction_3 = 0
-nb_reaction_4 = 0
+integer :: nb_hv, nb_pfunc1, nb_pfunc2, nb_pfunc3
+integer :: iq, ireact
+
+character(len = 128)              :: reactfile       ! reactions table file name
+character(len = 128)              :: monoreact       ! photochemical reactions table file name
+character(len = 128)              :: bimolreact      ! bimolecular reactions table file name
+character(len = 128)              :: quadrareact     ! quadratic reactions table file name
+integer                           :: nbq             ! number of species in reactions file
+integer                           :: pnlines         ! number of lines in photochemical reactions file
+integer                           :: bnlines         ! number of lines in bimolecular reactions file
+integer                           :: qnlines         ! number of lines in quadratic reactions file
+integer                           :: pnreact         ! number of reaction in photochemical reactions file
+integer                           :: bnreact         ! number of reaction in bimolecular reactions file
+integer                           :: qnreact         ! number of reaction in quadratic reactions file
+integer                           :: specheck(nesp)  ! to count the species of traceur.def in reactions file
+integer                           :: specheckr(nesp) ! to count the reactant species of traceur.def in reactions file
+integer                           :: specheckp(nesp) ! to count the product species of traceur.def in reactions file
+
+nb_phot        = 0
+nb_reaction_3  = 0
+nb_reaction_4  = 0
+nb_phot_hv_max = 0
+
+nb_hv          = 0
+nb_pfunc1      = 0
+nb_pfunc2      = 0
+nb_pfunc3      = 0
 
 !===========================================================
-!      O2 + hv -> O + O
+!  Read chemical reactions
 !===========================================================
 
-nb_phot = nb_phot + 1
-
-indice_phot(nb_phot) = z3spec(1.0, i_o2, 2.0, i_o, 0.0, i_dummy) 
+! Get number of reactions
+pnlines        = 0
+bnlines        = 0
+qnlines        = 0
+nreact         = 0
+pnreact        = 0
+bnreact        = 0
+qnreact        = 0
+
+write(*,*) "Read photochemical reaction"
+ monoreact = "monoreact" ! default
+call getin_p("monoreact",monoreact) ! default path
+write(*,*) " monoreact = ",trim(monoreact)
+
+write(*,*) "Read bimolecular reaction"
+ bimolreact = "bimolreact" ! default
+call getin_p("bimolreact",bimolreact) ! default path
+write(*,*) " bimolreact = ",trim(bimolreact)
+
+write(*,*) "Read quadratic reaction"
+ quadrareact = "quadrareact" ! default
+call getin_p("quadrareact",quadrareact) ! default path
+write(*,*) " quadrareact = ",trim(quadrareact)
+
+call count_react(monoreact,pnlines,pnreact,nb_phot,nb_hv,nb_pfunc1,nb_pfunc2,nb_pfunc3)
+call count_react(bimolreact,bnlines,bnreact,nb_reaction_4,nb_hv,nb_pfunc1,nb_pfunc2,nb_pfunc3)
+call count_react(quadrareact,qnlines,qnreact,nb_reaction_3,nb_hv,nb_pfunc1,nb_pfunc2,nb_pfunc3)
+nreact = pnreact + bnreact + qnreact
+
+!!!!!!!!!!! Hard coding reaction !!!!!!!!!!!!!!!!!!!!!!!!!!!
+nb_phot       = nb_phot       + nphot_hard_coding
+nb_reaction_4 = nb_reaction_4 + n4_hard_coding
+nb_reaction_3 = nb_reaction_3 + n3_hard_coding
+!!!!!!!!!!! END Hard coding reaction !!!!!!!!!!!!!!!!!!!!!!!
+
+write(*,*)'number of reaction in reaction files is = ',nreact
+print*, 'nb_phot       = ', nb_phot
+print*, 'nb_reaction_4 = ', nb_reaction_4
+print*, 'nb_reaction_3 = ', nb_reaction_3
+print*, '****************'
+print*, 'nb_hv         = ', nb_hv
+print*, 'nb_pfunc1     = ', nb_pfunc1
+print*, 'nb_pfunc2     = ', nb_pfunc2
+print*, 'nb_pfunc3     = ', nb_pfunc3
+nb_phot_max       = nb_phot
+nb_reaction_4_max = nb_reaction_4
+nb_reaction_3_max = nb_reaction_3
+nb_hv_max         = nb_hv
+nb_pfunc1_max     = nb_pfunc1
+nb_pfunc2_max     = nb_pfunc2
+nb_pfunc3_max     = nb_pfunc3
+
+! Allocate
+allocate(indice_phot(nb_phot_max))
+allocate(indice_4(nb_reaction_4_max))
+allocate(indice_3(nb_reaction_3_max))
+allocate(rtype(nreact))
+allocate(third_body(nreact))
+allocate(three_prod(nreact))
+allocate(jlabel(nb_phot_hv_max,2))
+allocate(jparamline(nb_phot_hv_max))
+allocate(pfunc1_param(nb_pfunc1_max))
+allocate(pfunc2_param(nb_pfunc2_max))
+allocate(pfunc3_param(nb_pfunc3_max))
+
+! Get reactants, products and number of species in reactfile
+! inititialize variables
+nbq             = 0
+specheck(:)     = 0
+specheckr(:)    = 0
+specheckp(:)    = 0
+rtype(:)        = 0
+third_body(:)   = 0
+pfunc1_param(:) = rtype1(0.,0.,0.,0.,0.)
+pfunc2_param(:) = rtype2(0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.)
+pfunc3_param(:) = rtype3(0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.)
+nb_pfunc1       = 0
+nb_pfunc2       = 0
+nb_pfunc3       = 0
+three_prod(:)   = .false.
+jlabel(:,:)     = ''
+jparamline(:)   = ''
+
+call get_react(monoreact,pnlines,pnreact,rtype(1:pnreact),third_body(1:pnreact),three_prod(1:pnreact),    &
+               nb_phot,specheck,specheckr,specheckp,'vphot',nbq,nb_pfunc1,nb_pfunc2,nb_pfunc3)
+call get_react(bimolreact,bnlines,bnreact,rtype(pnreact+1:pnreact+bnreact),third_body(pnreact+1:pnreact+bnreact), &
+               three_prod(pnreact+1:pnreact+bnreact),nb_reaction_4,specheck,specheckr,specheckp,'v4',nbq,nb_pfunc1,nb_pfunc2,nb_pfunc3)
+call get_react(quadrareact,qnlines,qnreact,rtype(pnreact+bnreact+1:nreact),third_body(pnreact+bnreact+1:nreact),  &
+               three_prod(pnreact+bnreact+1:nreact),nb_reaction_3,specheck,specheckr,specheckp,'v3',nbq,nb_pfunc1,nb_pfunc2,nb_pfunc3)
+
+! rewrite jlabel corretly for output
+do ireact=1,nb_phot_hv_max
+  if (three_prod(ireact)) then
+    jlabel(ireact+1:nb_phot_hv_max,2) = jlabel(ireact:nb_phot_hv_max-1,2)
+    jlabel(ireact+1:nb_phot_hv_max,1) = jlabel(ireact:nb_phot_hv_max-1,1)
+    jlabel(ireact,1) = trim(jlabel(ireact,1))//'_a'
+    jlabel(ireact+1,1) = trim(jlabel(ireact+1,1))//'_b'
+  end if
+end do
+
+!!!!!!!!!!! Hard coding reaction !!!!!!!!!!!!!!!!!!!!!!!!!!!
+call indice_HC(nb_phot,nb_reaction_4,nb_reaction_3)
+!!!!!!!!!!! END Hard coding reaction !!!!!!!!!!!!!!!!!!!!!!!
+
+write(*,*)'number of species in reaction files is = ',nbq
+write(*,*)'species in reaction files are:'
+
+do iq=1,nesp
+  if (specheck(iq)==1) print*, chemnoms(iq)
+end do
 
 !===========================================================
-!      O2 + hv -> O + O(1D)
+!  check species only destroy or product
 !===========================================================
 
-nb_phot = nb_phot + 1
-
-indice_phot(nb_phot) = z3spec(1.0, i_o2, 1.0, i_o, 1.0, i_o1d) 
+do iq=1,nesp
+  if (specheckr(iq)/=specheckp(iq)) then
+    if (specheckr(iq)==0 .and. specheckp(iq)==1) then
+      print*, 'WARNING: ', chemnoms(iq),' is only product'
+    else if (specheckr(iq)==1 .and. specheckp(iq)==0) then
+      print*, 'WARNING: ', chemnoms(iq),' is only destroy'
+    else
+      print*, 'Error in indice: bad value in specheckr or specheckp'
+      stop
+    end if
+  end if
+end do 
 
 !===========================================================
-!      CO2 + hv -> CO + O
+!  check stochiometry
 !===========================================================
 
-nb_phot = nb_phot + 1
-
-indice_phot(nb_phot) = z3spec(1.0, i_co2, 1.0, i_co, 1.0, i_o) 
-
-!===========================================================
-!      CO2 + hv -> CO + O(1D)
-!===========================================================
-
-nb_phot = nb_phot + 1
-
-indice_phot(nb_phot) = z3spec(1.0, i_co2, 1.0, i_co, 1.0, i_o1d) 
-
-!===========================================================
-!      O3 + hv -> O2 + O(1D)
-!===========================================================
-
-nb_phot = nb_phot + 1
-
-indice_phot(nb_phot) = z3spec(1.0, i_o3, 1.0, i_o2, 1.0, i_o1d) 
-
-!===========================================================
-!      O3 + hv -> O2 + O
-!===========================================================
-
-nb_phot = nb_phot + 1
-
-indice_phot(nb_phot) = z3spec(1.0, i_o3, 1.0, i_o2, 1.0, i_o) 
-
-!===========================================================
-!      H2O + hv -> H + OH
-!===========================================================
-
-nb_phot = nb_phot + 1
-
-indice_phot(nb_phot) = z3spec(1.0, i_h2o, 1.0, i_h, 1.0, i_oh) 
-
-!===========================================================
-!      H2O2 + hv -> OH + OH
-!===========================================================
-
-nb_phot = nb_phot + 1
-
-indice_phot(nb_phot) = z3spec(1.0, i_h2o2, 2.0, i_oh, 0.0, i_dummy) 
-
-!===========================================================
-!      HO2 + hv -> OH + O
-!===========================================================
-
-nb_phot = nb_phot + 1
-
-indice_phot(nb_phot) = z3spec(1.0, i_ho2, 1.0, i_oh, 1.0, i_o) 
-
-!===========================================================
-!      NO + hv -> N + O
-!===========================================================
-
-nb_phot = nb_phot + 1
-
-indice_phot(nb_phot) = z3spec(1.0, i_no, 1.0, i_n, 1.0, i_o) 
-
-!===========================================================
-!      NO2 + hv -> NO + O
-!===========================================================
-
-nb_phot = nb_phot + 1
-
-indice_phot(nb_phot) = z3spec(1.0, i_no2, 1.0, i_no, 1.0, i_o) 
-
-!===========================================================
-!      a001 : O + O2 + CO2 -> O3 + CO2
-!===========================================================
-
-nb_reaction_4 = nb_reaction_4 + 1
-
-indice_4(nb_reaction_4) = z4spec(1.0, i_o, 1.0, i_o2, 1.0, i_o3, 0.0, i_dummy) 
-
-!===========================================================
-!      a002 : O + O + CO2 -> O2 + CO2
-!===========================================================
-
-nb_reaction_3 = nb_reaction_3 + 1
-
-indice_3(nb_reaction_3) = z3spec(2.0, i_o, 1.0, i_o2, 0.0, i_dummy) 
-
-!===========================================================
-!      a003 : O + O3 -> O2 + O2
-!===========================================================
-
-nb_reaction_4 = nb_reaction_4 + 1
-
-indice_4(nb_reaction_4) = z4spec(1.0, i_o, 1.0, i_o3, 2.0, i_o2, 0.0, i_dummy) 
-
-!===========================================================
-!      b001 : O(1D) + CO2 -> O + CO2
-!===========================================================
-
-nb_phot = nb_phot + 1
-
-indice_phot(nb_phot) = z3spec(1.0, i_o1d, 1.0, i_o, 0.0, i_dummy) 
-
-!===========================================================
-!      b002 : O(1D) + H2O -> OH + OH
-!===========================================================
-
-nb_reaction_4 = nb_reaction_4 + 1
-
-indice_4(nb_reaction_4) = z4spec(1.0, i_o1d, 1.0, i_h2o, 2.0, i_oh, 0.0, i_dummy) 
-
-!===========================================================
-!      b003 : O(1D) + H2 -> OH + H
-!===========================================================
-
-nb_reaction_4 = nb_reaction_4 + 1
-
-indice_4(nb_reaction_4) = z4spec(1.0, i_o1d, 1.0, i_h2, 1.0, i_oh, 1.0, i_h) 
-
-!===========================================================
-!      b004 : O(1D) + O2 -> O + O2
-!===========================================================
-
-nb_phot = nb_phot + 1
-
-indice_phot(nb_phot) = z3spec(1.0, i_o1d, 1.0, i_o, 0.0, i_dummy) 
-
-!===========================================================
-!      b005 : O(1D) + O3 -> O2 + O2
-!===========================================================
-
-nb_reaction_4 = nb_reaction_4 + 1
-
-indice_4(nb_reaction_4) = z4spec(1.0, i_o1d, 1.0, i_o3, 2.0, i_o2, 0.0, i_dummy) 
-
-!===========================================================
-!      b006 : O(1D) + O3 -> O2 + O + O
-!===========================================================
-
-nb_reaction_4 = nb_reaction_4 + 1
-
-indice_4(nb_reaction_4) = z4spec(1.0, i_o1d, 1.0, i_o3, 1.0, i_o2, 2.0, i_o) 
-
-!===========================================================
-!      c001 : O + HO2 -> OH + O2
-!===========================================================
-
-nb_reaction_4 = nb_reaction_4 + 1
-
-indice_4(nb_reaction_4) = z4spec(1.0, i_o, 1.0, i_ho2, 1.0, i_oh, 1.0, i_o2) 
-
-!===========================================================
-!      c002 : O + OH -> O2 + H
-!===========================================================
-
-nb_reaction_4 = nb_reaction_4 + 1
-
-indice_4(nb_reaction_4) = z4spec(1.0, i_o, 1.0, i_oh, 1.0, i_o2, 1.0, i_h) 
-
-!===========================================================
-!      c003 : H + O3 -> OH + O2
-!===========================================================
-
-nb_reaction_4 = nb_reaction_4 + 1
-
-indice_4(nb_reaction_4) = z4spec(1.0, i_h, 1.0, i_o3, 1.0, i_oh, 1.0, i_o2) 
-
-!===========================================================
-!      c004 : H + HO2 -> OH + OH
-!===========================================================
-
-nb_reaction_4 = nb_reaction_4 + 1
-
-indice_4(nb_reaction_4) = z4spec(1.0, i_h, 1.0, i_ho2, 2.0, i_oh, 0.0, i_dummy) 
-
-!===========================================================
-!      c005 : H + HO2 -> H2 + O2
-!===========================================================
-
-nb_reaction_4 = nb_reaction_4 + 1
-
-indice_4(nb_reaction_4) = z4spec(1.0, i_h, 1.0, i_ho2, 1.0, i_h2, 1.0, i_o2) 
-
-!===========================================================
-!      c006 : H + HO2 -> H2O + O
-!===========================================================
-
-nb_reaction_4 = nb_reaction_4 + 1
-
-indice_4(nb_reaction_4) = z4spec(1.0, i_h, 1.0, i_ho2, 1.0, i_h2o, 1.0, i_o) 
-
-!===========================================================
-!      c007 : OH + HO2 -> H2O + O2
-!===========================================================
-
-nb_reaction_4 = nb_reaction_4 + 1
-
-indice_4(nb_reaction_4) = z4spec(1.0, i_oh, 1.0, i_ho2, 1.0, i_h2o, 1.0, i_o2) 
-
-!===========================================================
-!      c008 : HO2 + HO2 -> H2O2 + O2
-!===========================================================
-
-nb_reaction_3 = nb_reaction_3 + 1
-
-indice_3(nb_reaction_3) = z3spec(2.0, i_ho2, 1.0, i_h2o2, 1.0, i_o2) 
-
-!===========================================================
-!      c009 : OH + H2O2 -> H2O + HO2
-!===========================================================
-
-nb_reaction_4 = nb_reaction_4 + 1
-
-indice_4(nb_reaction_4) = z4spec(1.0, i_oh, 1.0, i_h2o2, 1.0, i_h2o, 1.0, i_ho2) 
-
-!===========================================================
-!      c010 : OH + H2 -> H2O + H
-!===========================================================
-
-nb_reaction_4 = nb_reaction_4 + 1
-
-indice_4(nb_reaction_4) = z4spec(1.0, i_oh, 1.0, i_h2, 1.0, i_h2o, 1.0, i_h) 
-
-!===========================================================
-!      c011 : H + O2 + CO2 -> HO2 + CO2
-!===========================================================
-
-nb_reaction_4 = nb_reaction_4 + 1
-
-indice_4(nb_reaction_4) = z4spec(1.0, i_h, 1.0, i_o2, 1.0, i_ho2, 0.0, i_dummy) 
-
-!===========================================================
-!      c012 : O + H2O2 -> OH + HO2
-!===========================================================
-
-nb_reaction_4 = nb_reaction_4 + 1
-
-indice_4(nb_reaction_4) = z4spec(1.0, i_o, 1.0, i_h2o2, 1.0, i_oh, 1.0, i_ho2) 
-
-!===========================================================
-!      c013 : OH + OH -> H2O + O
-!===========================================================
-
-nb_reaction_3 = nb_reaction_3 + 1
-
-indice_3(nb_reaction_3) = z3spec(2.0, i_oh, 1.0, i_h2o, 1.0, i_o) 
-
-!===========================================================
-!      c014 : OH + O3 -> HO2 + O2 
-!===========================================================
-
-nb_reaction_4 = nb_reaction_4 + 1
-
-indice_4(nb_reaction_4) = z4spec(1.0, i_oh, 1.0, i_o3, 1.0, i_ho2, 1.0, i_o2) 
-
-!===========================================================
-!      c015 : HO2 + O3 -> OH + O2 + O2 
-!===========================================================
-
-nb_reaction_4 = nb_reaction_4 + 1
-
-indice_4(nb_reaction_4) = z4spec(1.0, i_ho2, 1.0, i_o3, 1.0, i_oh, 2.0, i_o2) 
-
-!===========================================================
-!      c016 : HO2 + HO2 + CO2 -> H2O2 + O2 + CO2 
-!===========================================================
-
-nb_reaction_3 = nb_reaction_3 + 1
-
-indice_3(nb_reaction_3) = z3spec(2.0, i_ho2, 1.0, i_h2o2, 1.0, i_o2) 
-
-!===========================================================
-!      c017 : OH + OH + CO2 -> H2O2 + CO2 
-!===========================================================
-
-nb_reaction_3 = nb_reaction_3 + 1
-
-indice_3(nb_reaction_3) = z3spec(2.0, i_oh, 1.0, i_h2o2, 0.0, i_dummy) 
-
-!===========================================================
-!      c018 : H + H + CO2 -> H2 + CO2 
-!===========================================================
-
-nb_reaction_3 = nb_reaction_3 + 1
-
-indice_3(nb_reaction_3) = z3spec(2.0, i_h, 1.0, i_h2, 0.0, i_dummy) 
-
-!===========================================================
-!      d001 : NO2 + O -> NO + O2 
-!===========================================================
-
-nb_reaction_4 = nb_reaction_4 + 1
-
-indice_4(nb_reaction_4) = z4spec(1.0, i_no2, 1.0, i_o, 1.0, i_no, 1.0, i_o2) 
-
-!===========================================================
-!      d002 : NO + O3 -> NO2 + O2 
-!===========================================================
-
-nb_reaction_4 = nb_reaction_4 + 1
-
-indice_4(nb_reaction_4) = z4spec(1.0, i_no, 1.0, i_o3, 1.0, i_no2, 1.0, i_o2) 
-
-!===========================================================
-!      d003 : NO + HO2 -> NO2 + OH 
-!===========================================================
-
-nb_reaction_4 = nb_reaction_4 + 1
-
-indice_4(nb_reaction_4) = z4spec(1.0, i_no, 1.0, i_ho2, 1.0, i_no2, 1.0, i_oh) 
-
-!===========================================================
-!      d004 : N + NO -> N2 + O 
-!===========================================================
-
-nb_reaction_4 = nb_reaction_4 + 1
-
-indice_4(nb_reaction_4) = z4spec(1.0, i_n, 1.0, i_no, 1.0, i_n2, 1.0, i_o) 
-
-!===========================================================
-!      d005 : N + O2 -> NO + O 
-!===========================================================
-
-nb_reaction_4 = nb_reaction_4 + 1
-
-indice_4(nb_reaction_4) = z4spec(1.0, i_n, 1.0, i_o2, 1.0, i_no, 1.0, i_o) 
-
-!===========================================================
-!      d006 : NO2 + H -> NO + OH 
-!===========================================================
-
-nb_reaction_4 = nb_reaction_4 + 1
-
-indice_4(nb_reaction_4) = z4spec(1.0, i_no2, 1.0, i_h, 1.0, i_no, 1.0, i_oh) 
-
-!===========================================================
-!      d007 : N + O -> NO
-!===========================================================
-
-nb_reaction_4 = nb_reaction_4 + 1
-
-indice_4(nb_reaction_4) = z4spec(1.0, i_n, 1.0, i_o, 1.0, i_no, 0.0, i_dummy) 
-
-!===========================================================
-!      d008 : N + HO2 -> NO + OH
-!===========================================================
-
-nb_reaction_4 = nb_reaction_4 + 1
-
-indice_4(nb_reaction_4) = z4spec(1.0, i_n, 1.0, i_ho2, 1.0, i_no, 1.0, i_oh) 
-
-!===========================================================
-!      d009 : N + OH -> NO + H
-!===========================================================
-
-nb_reaction_4 = nb_reaction_4 + 1
-
-indice_4(nb_reaction_4) = z4spec(1.0, i_n, 1.0, i_oh, 1.0, i_no, 1.0, i_h) 
-
-!===========================================================
-!      e001 : CO + OH -> CO2 + H 
-!===========================================================
-
-nb_reaction_4 = nb_reaction_4 + 1
-
-indice_4(nb_reaction_4) = z4spec(1.0, i_co, 1.0, i_oh, 1.0, i_co2, 1.0, i_h) 
-
-!===========================================================
-!      e002 : CO + O + M -> CO2 + M 
-!===========================================================
-
-nb_reaction_4 = nb_reaction_4 + 1
-
-indice_4(nb_reaction_4) = z4spec(1.0, i_co, 1.0, i_o, 1.0, i_co2, 0.0, i_dummy) 
-
-!===========================================================
-!      h001: HO2 + ice -> products
-!            treated as
-!            HO2 -> 0.5 H2O + 0.75 O2
-!===========================================================
-
-nb_phot = nb_phot + 1
-
-indice_phot(nb_phot) = z3spec(1.0, i_ho2, 0.5, i_h2o, 0.75, i_o2) 
-
-!===========================================================
-!      h002: OH + ice -> products
-!            treated as
-!            OH -> 0.5 H2O + 0.25 O2
-!===========================================================
-
-nb_phot = nb_phot + 1
-
-indice_phot(nb_phot) = z3spec(1.0, i_oh, 0.5, i_h2o, 0.25, i_o2) 
-
-!===========================================================
-!      h003: H2O2 + ice -> products
-!            treated as
-!            H2O2 -> H2O + 0.5 O2
-!===========================================================
-
-nb_phot = nb_phot + 1
-
-indice_phot(nb_phot) = z3spec(1.0, i_h2o2, 1.0, i_h2o, 0.5, i_o2) 
-
-!===========================================================
-!      h004: HO2 + dust -> products
-!            treated as
-!            HO2 -> 0.5 H2O + 0.75 O2
-!===========================================================
-
-nb_phot = nb_phot + 1
-
-indice_phot(nb_phot) = z3spec(1.0, i_ho2, 0.5, i_h2o, 0.75, i_o2) 
-
-!===========================================================
-!      h005: H2O2 + dust -> products
-!            treated as
-!            H2O2 -> H2O + 0.5 O2
-!===========================================================
-
-nb_phot = nb_phot + 1
-
-indice_phot(nb_phot) = z3spec(1.0, i_h2o2, 1.0, i_h2o, 0.5, i_o2) 
+! If you found a way
 
 !===========================================================
@@ -1611,12 +1046,25 @@
 !===========================================================
 
-print*, 'nb_phot       = ', nb_phot
-print*, 'nb_reaction_4 = ', nb_reaction_4
-print*, 'nb_reaction_3 = ', nb_reaction_3
+if (jonline) then
+  nd = nb_hv_max
+else if (nb_phot_hv_max /= 0) then
+  print*,'calchim: Read photolysis lookup table'
+  call read_phototable
+end if
 
 if ((nb_phot /= nb_phot_max)             .or.  &
     (nb_reaction_3 /= nb_reaction_3_max) .or.  &
-    (nb_reaction_4 /= nb_reaction_4_max)) then
+    (nb_reaction_4 /= nb_reaction_4_max) .or.  &
+    (nd /= nb_hv_max)) then
+   print*, 'nb_phot       = ', nb_phot
+   print*, 'nb_reaction_4 = ', nb_reaction_4
+   print*, 'nb_reaction_3 = ', nb_reaction_3
+   print*, 'nd            = ', nd
    print*, 'wrong dimensions in indice' 
+   print*, 'nb_phot_max       = ', nb_phot_max
+   print*, 'nb_reaction_4_max = ', nb_reaction_4_max
+   print*, 'nb_reaction_3_max = ', nb_reaction_3_max
+   print*, 'nb_phot_hv_max    = ', nb_phot_hv_max
+   print*, 'nb_hv_max         = ', nb_hv_max
    stop
 end if  
@@ -1626,16 +1074,7 @@
 !*****************************************************************
 
-      subroutine gcmtochim(nlayer, nq, zycol, lswitch, nesp,         &
-                           i_co2, i_co, i_o, i_o1d, i_o2, i_o3, i_h, &
-                           i_h2, i_oh, i_ho2, i_h2o2, i_h2o,         &
-                           i_n, i_n2d, i_no, i_no2, i_n2,            &
-                           dens, rm, c) 
+      subroutine gcmtochim(nlayer, zycol, lswitch, nesp, dens, rm, c) 
 
 !*****************************************************************
-
-      use tracer_h, only: igcm_co2, igcm_co, igcm_o, igcm_o1d,         &
-     &                      igcm_o2, igcm_o3, igcm_h, igcm_h2, igcm_oh,  &
-     &                      igcm_ho2, igcm_h2o2, igcm_h2o_vap,           &
-     &                      igcm_n, igcm_n2d, igcm_no, igcm_no2, igcm_n2
 
       use callkeys_mod
@@ -1649,13 +1088,8 @@
       
       integer, intent(in) :: nlayer ! number of atmospheric layers
-      integer, intent(in) :: nq     ! number of tracers in the gcm
-      integer :: nesp               ! number of species in the chemistry
+      integer, intent(in) :: nesp   ! number of species in the chemistry
       integer :: lswitch            ! interface level between chemistries
 
-      integer :: i_co2, i_co, i_o, i_o1d, i_o2, i_o3, i_h,           &
-                 i_h2, i_oh, i_ho2, i_h2o2, i_h2o,                   &
-                 i_n, i_n2d, i_no, i_no2, i_n2
-
-      real :: zycol(nlayer,nq)      ! volume mixing ratios in the gcm
+      real :: zycol(nlayer,nesp)    ! volume mixing ratios in the gcm
       real :: dens(nlayer)          ! total number density (molecule.cm-3) 
 
@@ -1672,84 +1106,7 @@
 
       integer      :: l, iesp
-      logical,save :: firstcall = .true.
       
+      rm(:,:) = 0.
       
-!     first call initializations
-
-      if (firstcall) then
-
-!       identify the indexes of the tracers we need
-
-         if (igcm_co2 == 0) then
-            write(*,*) "gcmtochim: Error; no CO2 tracer !!!"
-            stop
-         endif
-         if (igcm_co == 0) then
-            write(*,*) "gcmtochim: Error; no CO tracer !!!"
-            stop
-         end if
-         if (igcm_o == 0) then
-            write(*,*) "gcmtochim: Error; no O tracer !!!"
-            stop
-         end if
-         if (igcm_o1d == 0) then
-            write(*,*) "gcmtochim: Error; no O1D tracer !!!"
-            stop
-         end if
-         if (igcm_o2 == 0) then
-            write(*,*) "gcmtochim: Error; no O2 tracer !!!"
-            stop
-         end if
-         if (igcm_o3 == 0) then
-            write(*,*) "gcmtochim: Error; no O3 tracer !!!"
-            stop
-         end if
-         if (igcm_h == 0) then
-            write(*,*) "gcmtochim: Error; no H tracer !!!"
-            stop
-         end if
-         if (igcm_h2 == 0) then
-            write(*,*) "gcmtochim: Error; no H2 tracer !!!"
-            stop
-         end if
-         if (igcm_oh == 0) then
-            write(*,*) "gcmtochim: Error; no OH tracer !!!"
-            stop
-         end if
-         if (igcm_ho2 == 0) then
-            write(*,*) "gcmtochim: Error; no HO2 tracer !!!"
-            stop
-         end if
-         if (igcm_h2o2 == 0) then
-            write(*,*) "gcmtochim: Error; no H2O2 tracer !!!"
-            stop
-         end if
-         if (igcm_n == 0) then
-            write(*,*) "gcmtochim: Error; no N tracer !!!"
-!            stop
-         end if
-         if (igcm_n2d == 0) then
-            write(*,*) "gcmtochim: Error; no N2D tracer !!!"
-!            stop
-         end if
-         if (igcm_no == 0) then
-            write(*,*) "gcmtochim: Error; no NO tracer !!!"
-!            stop
-         end if
-         if (igcm_no2 == 0) then
-            write(*,*) "gcmtochim: Error; no NO2 tracer !!!"
-!            stop
-         end if
-         if (igcm_n2 == 0) then
-            write(*,*) "gcmtochim: Error; no N2 tracer !!!"
-            stop
-         end if
-         if (igcm_h2o_vap == 0) then
-            write(*,*) "gcmtochim: Error; no water vapor tracer !!!"
-            stop
-         end if
-         firstcall = .false.
-      end if ! of if (firstcall)
-
 !ccccccccccccccccccccccccccccccccccccccccccccccccccccccc
 !     initialise mixing ratios
@@ -1757,21 +1114,5 @@
 
       do l = 1,lswitch-1
-         rm(l,i_co2)  = zycol(l, igcm_co2)
-         rm(l,i_co)   = zycol(l, igcm_co)
-         rm(l,i_o)    = zycol(l, igcm_o)
-         rm(l,i_o1d)  = zycol(l, igcm_o1d)
-         rm(l,i_o2)   = zycol(l, igcm_o2)
-         rm(l,i_o3)   = zycol(l, igcm_o3)
-         rm(l,i_h)    = zycol(l, igcm_h)
-         rm(l,i_h2)   = zycol(l, igcm_h2)
-         rm(l,i_oh)   = zycol(l, igcm_oh)
-         rm(l,i_ho2)  = zycol(l, igcm_ho2)
-         rm(l,i_h2o2) = zycol(l, igcm_h2o2)
-         rm(l,i_h2o)  = zycol(l, igcm_h2o_vap)
-         rm(l,i_n)    = zycol(l, igcm_n)
-         rm(l,i_n2d)  = zycol(l, igcm_n2d)
-         rm(l,i_no)   = zycol(l, igcm_no)
-         rm(l,i_no2)  = zycol(l, igcm_no2)
-         rm(l,i_n2)   = zycol(l, igcm_n2)
+         rm(l,:) = zycol(l,:)
       end do 
 
@@ -1794,15 +1135,8 @@
 !*****************************************************************
  
-      subroutine chimtogcm(nlayer, nq, zycol, lswitch, nesp,         &
-                           i_co2, i_co, i_o, i_o1d, i_o2, i_o3, i_h, &
-                           i_h2, i_oh, i_ho2, i_h2o2, i_h2o,         &
-                           i_n, i_n2d, i_no, i_no2, i_n2, dens, c) 
+      subroutine chimtogcm(nlayer, zycol, lswitch, nesp, dens, c) 
+
  
 !*****************************************************************
- 
-      use tracer_h, only: igcm_co2, igcm_co, igcm_o, igcm_o1d,          &
-                            igcm_o2, igcm_o3, igcm_h, igcm_h2, igcm_oh,   &
-                            igcm_ho2, igcm_h2o2, igcm_h2o_vap,            &
-                            igcm_n, igcm_n2d, igcm_no, igcm_no2, igcm_n2
 
       use callkeys_mod
@@ -1816,10 +1150,6 @@
  
       integer, intent(in) :: nlayer  ! number of atmospheric layers
-      integer, intent(in) :: nq      ! number of tracers in the gcm
-      integer :: nesp                ! number of species in the chemistry
+      integer, intent(in) :: nesp    ! number of species in the chemistry
       integer :: lswitch             ! interface level between chemistries
-      integer :: i_co2, i_co, i_o, i_o1d, i_o2, i_o3, i_h,       &
-                 i_h2, i_oh, i_ho2, i_h2o2, i_h2o,               &
-                 i_n, i_n2d, i_no, i_no2, i_n2
 
       real :: dens(nlayer)     ! total number density (molecule.cm-3) 
@@ -1830,5 +1160,5 @@
 !ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
        
-      real zycol(nlayer,nq)  ! volume mixing ratios in the gcm
+      real zycol(nlayer,nesp)  ! volume mixing ratios in the gcm
 
 !ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
